Index: etc/mtree/BSD.tests.dist
===================================================================
--- etc/mtree/BSD.tests.dist	(revision 261208)
+++ etc/mtree/BSD.tests.dist	(working copy)
@@ -81,6 +81,40 @@
         sys
             kern
             ..
+            pjdfstest
+                tests
+                    chflags
+                    ..
+                    chmod
+                    ..
+                    chown
+                    ..
+                    ftruncate
+                    ..
+                    granular
+                    ..
+                    link
+                    ..
+                    mkdir
+                    ..
+                    mkfifo
+                    ..
+                    mknod
+                    ..
+                    open
+                    ..
+                    rename
+                    ..
+                    rmdir
+                    ..
+                    symlink
+                    ..
+                    truncate
+                    ..
+                    unlink
+                    ..
+                ..
+            ..
         ..
         usr.bin
             atf
Index: tests/sys/Makefile
===================================================================
--- tests/sys/Makefile	(revision 261208)
+++ tests/sys/Makefile	(working copy)
@@ -2,13 +2,13 @@
 
 .include <bsd.own.mk>
 
+.PATH: ${.CURDIR}/..
+
+TESTS_SUBDIRS+=		pjdfstest
+
 SUBDIR= kern
 TESTSDIR= ${TESTSBASE}/sys
 
 KYUAFILE= yes
 
-CLEANFILES+= Kyuafile
-Kyuafile: ${.CURDIR}/../Kyuafile
-	cp -f ${.CURDIR}/../Kyuafile .
-
 .include <bsd.test.mk>
Index: tests/sys/pjdfstest/Makefile
===================================================================
--- tests/sys/pjdfstest/Makefile	(revision 0)
+++ tests/sys/pjdfstest/Makefile	(working copy)
@@ -0,0 +1,21 @@
+SUBDIR=		pjdfstest
+
+TESTS_SUBDIRS+=	tests
+
+TESTSDIR=	${TESTSBASE}/sys/pjdfstest
+
+KYUAFILE=	yes
+
+.PATH: ${.CURDIR}/../../
+
+test: .PHONY
+.if defined(PJDFSTEST_I_KNOW_WHAT_I_AM_DOING)
+	cd ${.CURDIR}/tests && make ${.TARGET}
+.else
+	@echo "Executing the pjdfstest from make test is potentially a really bad idea."
+	@echo
+	@echo "Call make test again like 'make PJDFSTEST_I_KNOW_WHAT_I_AM_DOING=1 test'"
+	@echo "if you want to give this a shot."
+.endif
+
+.include <bsd.test.mk>
Index: tests/sys/pjdfstest/pjdfstest/Makefile
===================================================================
--- tests/sys/pjdfstest/pjdfstest/Makefile	(revision 0)
+++ tests/sys/pjdfstest/pjdfstest/Makefile	(working copy)
@@ -0,0 +1,18 @@
+TOP=		${.CURDIR:H:H:H:H}
+
+.PATH: ${TOP}/tools/regression/pjdfstest
+
+FILES=		LICENSE \
+		README \
+
+BINDIR=		${TESTSBASE}/sys/pjdfstest
+PROG=		pjdfstest
+NO_MAN=
+
+CFLAGS=		-D__OS_FreeBSD__ -DHAS_LCHMOD -DHAS_CHFLAGS -DHAS_FCHFLAGS
+CFLAGS+=	-DHAS_CHFLAGSAT -DHAS_LCHFLAGS -DHAS_FREEBSD_ACL -DHAS_BINDAT
+CFLAGS+=	-DHAS_CONNECTAT
+
+WARNS?=		6
+
+.include <bsd.prog.mk>
Index: tests/sys/pjdfstest/tests/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/Makefile	(working copy)
@@ -0,0 +1,28 @@
+TOP=		${.CURDIR:H:H:H:H}
+
+.PATH:		${TOP}/tools/regression/pjdfstest/tests
+
+TESTSDIR=	${TESTSBASE}/sys/pjdfstest/tests
+
+SCRIPTSDIR=	${TESTSDIR}
+SCRIPTS+=	conf
+SCRIPTS+=	misc.sh
+SCRIPTSNAME_misc.sh=	misc.sh
+
+TESTS_SUBDIRS+=	chflags
+TESTS_SUBDIRS+=	chmod
+TESTS_SUBDIRS+=	chown
+TESTS_SUBDIRS+=	ftruncate
+TESTS_SUBDIRS+=	granular
+TESTS_SUBDIRS+=	link
+TESTS_SUBDIRS+=	mkdir
+TESTS_SUBDIRS+=	mkfifo
+TESTS_SUBDIRS+=	mknod
+TESTS_SUBDIRS+=	open
+TESTS_SUBDIRS+=	rename
+TESTS_SUBDIRS+=	rmdir
+TESTS_SUBDIRS+=	symlink
+TESTS_SUBDIRS+=	truncate
+TESTS_SUBDIRS+=	unlink
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/Makefile.inc
===================================================================
--- tests/sys/pjdfstest/tests/Makefile.inc	(revision 0)
+++ tests/sys/pjdfstest/tests/Makefile.inc	(working copy)
@@ -0,0 +1,9 @@
+TOP=	${.CURDIR:H:H:H:H:H}
+
+.PATH:	${TOP}/tools/regression/pjdfstest/tests/${.CURDIR:T}
+
+TESTSDIR= ${TESTSBASE}/sys/pjdfstest/tests/${.CURDIR:T}
+
+.for _T in ${TAP_TESTS_SH}
+TAP_TESTS_SH_SRC_${_T}=	${_T}.t
+.endfor
Index: tests/sys/pjdfstest/tests/chflags/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/chflags/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/chflags/Makefile	(working copy)
@@ -0,0 +1,16 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/chmod/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/chmod/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/chmod/Makefile	(working copy)
@@ -0,0 +1,15 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/chown/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/chown/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/chown/Makefile	(working copy)
@@ -0,0 +1,13 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/ftruncate/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/ftruncate/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/ftruncate/Makefile	(working copy)
@@ -0,0 +1,3 @@
+TAP_TESTS_SH+=	00
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/granular/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/granular/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/granular/Makefile	(working copy)
@@ -0,0 +1,8 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/link/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/link/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/link/Makefile	(working copy)
@@ -0,0 +1,20 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+TAP_TESTS_SH+=	14
+TAP_TESTS_SH+=	15
+TAP_TESTS_SH+=	16
+TAP_TESTS_SH+=	17
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/mkdir/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/mkdir/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/mkdir/Makefile	(working copy)
@@ -0,0 +1,15 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/mkfifo/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/mkfifo/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/mkfifo/Makefile	(working copy)
@@ -0,0 +1,15 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/mknod/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/mknod/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/mknod/Makefile	(working copy)
@@ -0,0 +1,14 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/open/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/open/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/open/Makefile	(working copy)
@@ -0,0 +1,27 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+TAP_TESTS_SH+=	14
+TAP_TESTS_SH+=	15
+TAP_TESTS_SH+=	16
+TAP_TESTS_SH+=	17
+TAP_TESTS_SH+=	18
+TAP_TESTS_SH+=	19
+TAP_TESTS_SH+=	20
+TAP_TESTS_SH+=	21
+TAP_TESTS_SH+=	22
+TAP_TESTS_SH+=	23
+TAP_TESTS_SH+=	24
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/rename/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/rename/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/rename/Makefile	(working copy)
@@ -0,0 +1,24 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+TAP_TESTS_SH+=	14
+TAP_TESTS_SH+=	15
+TAP_TESTS_SH+=	16
+TAP_TESTS_SH+=	17
+TAP_TESTS_SH+=	18
+TAP_TESTS_SH+=	19
+TAP_TESTS_SH+=	20
+TAP_TESTS_SH+=	21
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/rmdir/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/rmdir/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/rmdir/Makefile	(working copy)
@@ -0,0 +1,18 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+TAP_TESTS_SH+=	14
+TAP_TESTS_SH+=	15
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/symlink/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/symlink/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/symlink/Makefile	(working copy)
@@ -0,0 +1,15 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/truncate/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/truncate/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/truncate/Makefile	(working copy)
@@ -0,0 +1,17 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+TAP_TESTS_SH+=	14
+
+.include <tap.test.mk>
Index: tests/sys/pjdfstest/tests/unlink/Makefile
===================================================================
--- tests/sys/pjdfstest/tests/unlink/Makefile	(revision 0)
+++ tests/sys/pjdfstest/tests/unlink/Makefile	(working copy)
@@ -0,0 +1,16 @@
+TAP_TESTS_SH+=	00
+TAP_TESTS_SH+=	01
+TAP_TESTS_SH+=	02
+TAP_TESTS_SH+=	03
+TAP_TESTS_SH+=	04
+TAP_TESTS_SH+=	05
+TAP_TESTS_SH+=	06
+TAP_TESTS_SH+=	07
+TAP_TESTS_SH+=	08
+TAP_TESTS_SH+=	09
+TAP_TESTS_SH+=	10
+TAP_TESTS_SH+=	11
+TAP_TESTS_SH+=	12
+TAP_TESTS_SH+=	13
+
+.include <tap.test.mk>
